=== debian/control ===
Source: ycmd
Section: devel
Priority: optional
Maintainer: Onur Aslan <onur@onur.im>
Build-Depends: debhelper (>= 9),
 cmake,
 dh-python,
 flake8,
 python-bottle,
 python-dev,
 python-future,
 python-hamcrest,
 python-jedi,
 python-mock,
 python-nose,
 python-pep8,
 python-requests,
 python-setuptools,
 python-waitress,
 python-webtest,
 python3-nose,
 python3-hamcrest,
 python3-webtest,
 python3-jedi,
 python3-waitress,
 python3-bottle,
 python3-requests,
 google-mock,
 libclang-3.8-dev,
 libboost-python-dev,
 libboost-system-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libgtest-dev,
 node-typescript
X-Python-Version: >= 2.7
Standards-Version: 3.9.7
Homepage: https://github.com/Valloric/ycmd
Vcs-Git: https://anonscm.debian.org/git/collab-maint/ycmd.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ycmd.git

Package: ycmd
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends},
 python-bottle,
 python-future,
 python-jedi,
 python-requests (>= 2.2.1),
 python-waitress
Recommends: vim-youcompleteme,
 node-typescript,
 libclang-common-${misc:Clang-Ver}-dev
Description: code-completion & comprehension server
 ycmd is a server that provides APIs for code-completion and other
 code-comprehension use-cases like semantic GoTo commands (and others). For
 certain filetypes, ycmd can also provide diagnostic errors and warnings.
