=== debian/control ===
--- 
+++ 
@@ -9,11 +9,13 @@
  python-bottle,
  python-dev,
  python-future,
+ python-frozendict,
  python-hamcrest,
  python-jedi,
  python-mock,
  python-nose,
  python-pep8,
+ python-psutil,
  python-requests,
  python-setuptools,
  python-waitress,
@@ -25,8 +27,8 @@
  python3-waitress,
  python3-bottle,
  python3-requests,
- google-mock,
- libclang-3.8-dev,
+ googletest,
+ libclang-3.9-dev,
  libboost-python-dev,
  libboost-system-dev,
  libboost-filesystem-dev,
@@ -34,7 +36,7 @@
  libgtest-dev,
  node-typescript
 X-Python-Version: >= 2.7
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: https://github.com/Valloric/ycmd
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/ycmd.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ycmd.git
@@ -46,6 +48,7 @@
  ${python:Depends},
  python-bottle,
  python-future,
+ python-frozendict,
  python-jedi,
  python-requests (>= 2.2.1),
  python-waitress
